package org.netkernel.mod.architecture;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class EntityViewAccessor extends StandardAccessorImpl
{
	public static String formatViewPath(String aId)
	{	return "javascript:loadTab('/tools/ae/view/"+aId+"')";
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String viewId=aContext.getThisRequest().getArgumentValue("viewId");
		String entityId=aContext.getThisRequest().getArgumentValue("entityId");
		ISERep config = aContext.source("active:seConfig",ISERep.class);
		INKFResponseReadOnly respIn=config.generateView(viewId,entityId,aContext);
		INKFResponse resp=aContext.createResponseFrom(respIn);
		
		IHDSNode source=config.getSource(viewId);
		if (respIn.hasHeader("WrappedControlPanel"))
		{	if (!(respIn.getHeader("WrappedControlPanel") instanceof String))
			{	resp.setHeader("WrappedControlPanel", source.getFirstValue("name"));
			}		
			if (!respIn.hasHeader("WrappedControlPanelSubtitle") && source.getFirstValue("desc")!=null)
			{	resp.setHeader("WrappedControlPanelSubtitle", source.getFirstValue("desc"));
			}		
			if (!(respIn.hasHeader("WrappedControlPanelIcon")) && source.getFirstValue("icon")!=null )
			{	resp.setHeader("WrappedControlPanelIcon", source.getFirstValue("icon"));
			}		
		}
		
	}
}
