package org.netkernel.mod.architecture;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.meta.IEndpointMeta;
import org.netkernel.layer0.meta.IModuleMeta;
import org.netkernel.layer0.meta.IPhysicalEndpointMeta;
import org.netkernel.layer0.meta.IPrototypeMeta;
import org.netkernel.layer0.meta.IRepresentationMeta;
import org.netkernel.layer0.meta.ISpaceMeta;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.urii.IMetaRepresentation;

public class LegacyRedirector extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String entityId=aContext.getThisRequest().getArgumentValue("entityId");
		if (entityId!=null)
		{
			//determine type of entity
			String type=null;
			IRepDeployedModules modules=aContext.source("active:moduleList", IRepDeployedModules.class);
			IMetaRepresentation meta=modules.metadataForHash(entityId);
			if (meta instanceof IRepresentationMeta)
			{	type="representation";
			}
			else if (meta instanceof IPrototypeMeta)
			{	type="prototype";
			}
			else if (meta instanceof IEndpointMeta)
			{	type="endpoint";
			}
			else if (meta instanceof ISpaceMeta)
			{	type="space";
			}
			else if (meta instanceof IModuleMeta)
			{	type="module";
			}
			else if (meta instanceof IPhysicalEndpointMeta)
			{	type="physical";
			}
		
			//determine default view for this entity
			if (type!=null)
			{	ISERep config = aContext.source("active:seConfig",ISERep.class);
				IHDSNode firstView=config.getViewsFor(type).getFirstNode();
				String viewId=(String)firstView.getFirstValue("id");
				String url="/tools/ae/view/"+viewId+"/"+entityId;
				aContext.sink("httpResponse:/redirect", url);
				return;
			}
		}
		
		//fallback
		String url="/panel/urn:org:netkernel:nkse:control:panel:explorer";
		aContext.sink("httpResponse:/redirect", url);
	}

}
