package org.netkernel.mod.architecture.bits;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.boot.BootUtils;
import org.netkernel.layer0.meta.IModuleMeta;
import org.netkernel.layer0.nkf.*;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class ViewModuleXML extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String hash=aContext.getThisRequest().getArgumentValue("entityId");
		IRepDeployedModules modules=(IRepDeployedModules)aContext.source("active:moduleList",IRepDeployedModules.class);
		IModuleMeta meta=(IModuleMeta)modules.metadataForHash(hash);
		String sourceURI=BootUtils.fixURIString(meta.getSource().toString())+"module.xml";
		
		INKFRequest req=aContext.createRequest("active:xslt");
		req.addArgument("operator","res:/org/netkernel/mod/architecture/bits/styleModuleXML.xsl");
		req.addArgument("operand", sourceURI);
		req.addArgumentByValue("hash", hash);
		INKFResponseReadOnly respIn=aContext.issueRequestForResponse(req);
		
		INKFResponse resp=aContext.createResponseFrom(respIn);
		resp.setHeader("WrappedControlPanel", "View Module XML");
		resp.setHeader("WrappedControlPanelSubtitle", "for "+meta.getName());
		resp.setHeader("WrappedControlPanelIcon", "/tools/ae/pub/images/48/Module48.png");
		
	}
}
