<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xrl="http://netkernel.org/xrl">

	<xsl:output method="xml" />

	<xsl:template match="/data">
		<div>
			<script type="text/javascript">
			<xsl:comment>
					function onSubmit(name)
					{	document.form.action2.value=name;
						document.form.submit();
					}
					$(document).ready(function() {
						enableTextareaTab("script");
					}
					);
			</xsl:comment>
			</script>

			<div class="panel panel-default" style="padding: 10px;">
			<form name="form" action="scriptplaypen" enctype="application/x-www-form-urlencoded; charset=UTF-8" method="POST">
				<input type="hidden" name="action2" value=""/>
				<input type="hidden" name="identifier" value="{identifier}"/>
				<input type="hidden" name="space" value="{space}"/>
				<table class="title-table" style="width: 100%;">
					<tr>
						<td colspan="4">
						
							<xrl:include>
								<xrl:identifier>active:controlPanelInfoBox</xrl:identifier>
									<xrl:argument name="content">
						
							<div>
								The Scripting Playpen will run scripts in a safe and managed environment.
								Use it to experiment with scripts written in various languages
                or to perform runtime system diagnostics.

								The playpen provides a set of pre-written sample scripts
                and will save new custom scripts.
                Scripts are validated and errors are reported back to the browser.
                Support is provided for  
								<a href="/tools/search/?lucky=true&amp;search=DPML">DPML</a>,
								<a href="/tools/search/?lucky=true&amp;search=Beanshell">Beanshell</a>,
								<a href="/tools/search/?lucky=true&amp;search=Javascript">Javascript</a>,
								<a href="/tools/search/?lucky=true&amp;search=Python">Python</a>,
								<a href="/tools/search/?lucky=true&amp;search=Groovy">Groovy</a> and
								<a href="/tools/search/?lucky=true&amp;search=Ruby">Ruby</a>.
								For details of each specific scripting language see their reference guides
							</div>
										</xrl:argument>
									</xrl:include>
						</td>
					</tr>
          
					<tr>
						<td valign="top" align="right">Saved:</td>
						<td>
							<select size="1" name="example" onchange="onSubmit('')">
								<option value="">load a previously saved script</option>
								<xsl:for-each select="saves/save">
									<option value="{identifier}">
										<xsl:value-of select="name" />
									</option>
								</xsl:for-each>

							</select>
						</td>
						<td valign="top" align="right">Language:</td>
						<td>
							<select size="1" name="type">
								<option value="dpml">
									<xsl:if test="type='dpml'">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									DPML
								</option>
								<option value="bsh">
									<xsl:if test="type='bsh'">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									Beanshell
								</option>
								<option value="js">
									<xsl:if test="type='js'">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									Javascript</option>
								<option value="py">
									<xsl:if test="type='py'">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									Python</option>
								<option value="gy">
									<xsl:if test="type='gy'">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									Groovy</option>
								<option value="rb">
									<xsl:if test="type='rb'">
										<xsl:attribute name="selected">true</xsl:attribute>
									</xsl:if>
									Ruby</option>
							</select>
						</td>
					</tr>
					<tr>
						<td valign="top" align="right">Name:</td>
						<td colspan="2">
							<input type="text" name="name" value="{name}" size="40" />
						</td>
						<td />
					</tr>

					<tr>
						<td valign="top" align="right">Script:</td>
						<td colspan="2">
							<div style="margin-right: 1em;">
							<textarea id="script" name="script" cols="80" rows="30" wrap="off" style="font-size:8pt; width: 100%;">
								<xsl:choose>
									<xsl:when test="string-length(script)">
										<xsl:value-of select="translate(script, '&#xD;', '')"/>
									</xsl:when>
									<xsl:otherwise>// enter a script here or choose a saved example as a starting point
									</xsl:otherwise>
								</xsl:choose>
							</textarea></div>
						</td>
						<td valign="top" >
							<input type="button" onclick="onSubmit('save')" value="save" class="btn btn-default" />
							<div style="clear: both; margin-top: 4px;">
							<input type="button" onclick="onSubmit('execute')" value="execute" class="btn btn-primary" />
							</div>
						</td>
					</tr>
				</table>
			</form>
			</div>

		</div>
	</xsl:template>

</xsl:stylesheet>
